igeo

## Class IText

- java.lang.Object
- - igeo.IObject
  - - igeo.IGeometry
    - - igeo.IText

- All Implemented Interfaces:
    ITransformable

      public class IText
      extends IGeometry

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static double` | `defaultTextSize`
    `java.awt.Font` | `font`
    `ITextGeo` | `text`

    - ### Fields inherited from class igeo.IObject

      `attribute, dynamics, graphics, parameter, server, userData`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IText(IServerI s, IText text)`
    `IText(IServerI s, java.lang.String str, double fontSize, double x, double y, double z)`
    `IText(IServerI s, java.lang.String str, double fontSize, double x, double y, double z, double textDirX, double textDirY, double textDirZ)`
    `IText(IServerI s, java.lang.String str, double fontSize, double x, double y, double z, double textDirX, double textDirY, double textDirZ, double textUpDirX, double textUpDirY, double textUpDirZ)`
    `IText(IServerI s, java.lang.String str, double fontSize, IVecI pos)`
    `IText(IServerI s, java.lang.String str, double fontSize, IVecI pos, IVecI textDir)`
    `IText(IServerI s, java.lang.String str, double fontSize, IVecI pos, IVecI textDir, IVecI textUpDir)`
    `IText(IServerI s, java.lang.String str, IVecI pos, IVecI uvec, IVecI vvec)`
    `IText(IText text)`
    `IText(java.lang.String str, double fontSize, double x, double y, double z)`
    `IText(java.lang.String str, double fontSize, double x, double y, double z, double textDirX, double textDirY, double textDirZ)`
    `IText(java.lang.String str, double fontSize, double x, double y, double z, double textDirX, double textDirY, double textDirZ, double textUpDirX, double textUpDirY, double textUpDirZ)`
    `IText(java.lang.String str, double fontSize, IVecI pos)`
    `IText(java.lang.String str, double fontSize, IVecI pos, IVecI textDir)`
    `IText(java.lang.String str, double fontSize, IVecI pos, IVecI textDir, IVecI textUpDir)`
    `IText(java.lang.String str, IVecI pos, IVecI uvec, IVecI vvec)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `IText` | `add(double x, double y, double z)` ITransformable API
    `IText` | `add(double f, IVecI v)` scale add alias
    `IText` | `add(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IText` | `add(IDoubleI f, IVecI v)` scale add alias
    `IText` | `add(IVecI v)`
    `IText` | `add(IVecI v, double f)` scale add
    `IText` | `add(IVecI v, IDoubleI f)` scale add
    `IText` | `alignBottom()`
    `IText` | `alignCenter()`
    `IText` | `alignLeft()`
    `IText` | `alignMiddle()`
    `IText` | `alignRight()`
    `IText` | `alignTop()`
    `IText` | `attr(IAttribute at)` set attributes
    `IVec` | `center()` returns center of geometry object
    `IText` | `clr(java.awt.Color c)`
    `IText` | `clr(java.awt.Color c, double alpha)`
    `IText` | `clr(java.awt.Color c, float alpha)`
    `IText` | `clr(java.awt.Color c, int alpha)`
    `IText` | `clr(double dgray)`
    `IText` | `clr(double dgray, double dalpha)`
    `IText` | `clr(double dr, double dg, double db)`
    `IText` | `clr(double dr, double dg, double db, double da)`
    `IText` | `clr(float fgray)`
    `IText` | `clr(float fgray, float falpha)`
    `IText` | `clr(float fr, float fg, float fb)`
    `IText` | `clr(float fr, float fg, float fb, float fa)`
    `IText` | `clr(IColor c)` to set an object color
    `IText` | `clr(IColor c, double alpha)` to set color, with alpha value overwritten
    `IText` | `clr(IColor c, float alpha)` to set color, with alpha value overwritten
    `IText` | `clr(IColor c, int alpha)` to set color, with alpha value overwritten
    `IText` | `clr(int gray)`
    `IText` | `clr(int gray, int alpha)`
    `IText` | `clr(int r, int g, int b)`
    `IText` | `clr(int r, int g, int b, int a)`
    `IText` | `clr(IObject o)` to set the same color with the object
    `IVec` | `corner(int i, int j)`
    `IText` | `cp()` alias of dup()
    `IText` | `cp(double x, double y, double z)` cp() is alias of dup().add()
    `IText` | `cp(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IText` | `cp(IVecI v)`
    `IGraphicObject` | `createGraphic(IGraphicMode m)`
    `IText` | `div(double v)`
    `IText` | `div(IDoubleI v)`
    `IText` | `dup()` duplicate object
    `IText` | `flip()` alias of neg
    `java.awt.Font` | `font()`
    `IText` | `font(java.awt.Font f)`
    `IText` | `font(processing.core.PFont f)`
    `IText` | `font(java.lang.String fontName)`
    `IText` | `font(java.lang.String fontName, int fontStyle)`
    `IText` | `font(java.lang.String fontName, int fontStyle, int fontPixelResolution)`
    `IText` | `hide()`
    `IText` | `hsb(double dh, double ds, double db)`
    `IText` | `hsb(double dh, double ds, double db, double da)`
    `IText` | `hsb(float h, float s, float b)`
    `IText` | `hsb(float h, float s, float b, float a)`
    `void` | `initText(IServerI s)`
    `boolean` | `isAlignBottom()`
    `boolean` | `isAlignCenter()`
    `boolean` | `isAlignLeft()`
    `boolean` | `isAlignMiddle()`
    `boolean` | `isAlignRight()`
    `boolean` | `isAlignTop()`
    `IText` | `layer(ILayer l)` Set layer by ILayer object
    `IText` | `layer(java.lang.String layerName)` Set layer by layer name.
    `IText` | `mirror(IVecI planeDir)` mirror is alias of ref
    `IText` | `mirror(IVecI center, IVecI planeDir)`
    `IText` | `mul(double v)`
    `IText` | `mul(IDoubleI v)`
    `IText` | `mv(double x, double y, double z)` mv() is alias of add()
    `IText` | `mv(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IText` | `mv(IVecI v)`
    `IText` | `neg()`
    `IVec` | `pos()`
    `IText` | `pos(IVecI v)`
    `IText` | `ref(IVecI planeDir)` reflect(mirror) 3 dimensionally to the other side of the plane
    `IText` | `ref(IVecI center, IVecI planeDir)`
    `IText` | `rev()` alias of neg
    `IText` | `rot(double angle)`
    `IText` | `rot(IDoubleI angle)` rotation around z-axis and origin
    `IText` | `rot(IVecI axis, double angle)`
    `IText` | `rot(IVecI axis, IDoubleI angle)` rotation around axis vector
    `IText` | `rot(IVecI axis, IVecI destDir)` rotate to destination direction vector
    `IText` | `rot(IVecI center, IVecI axis, double angle)`
    `IText` | `rot(IVecI center, IVecI axis, IDoubleI angle)` rotation around axis vector and center
    `IText` | `rot(IVecI center, IVecI axis, IVecI destPt)` rotate to destination point location
    `IText` | `rot2(double angle)` rotation on xy-plane around origin; same with rot(double)
    `IText` | `rot2(IDoubleI angle)` rotation on xy-plane around origin; same with rot(IDoubleI)
    `IText` | `rot2(IVecI destDir)` rotation on xy-plane to destination direction vector
    `IText` | `rot2(IVecI center, double angle)`
    `IText` | `rot2(IVecI center, IDoubleI angle)` rotation on xy-plane around center
    `IText` | `rot2(IVecI center, IVecI destPt)` rotation on xy-plane to destination point location
    `IText` | `scale(double f)`
    `IText` | `scale(IDoubleI f)` alias of mul
    `IText` | `scale(IVecI center, double f)`
    `IText` | `scale(IVecI center, IDoubleI f)`
    `IText` | `scale1d(IVecI axis, double f)` scale only in 1 direction
    `IText` | `scale1d(IVecI axis, IDoubleI f)`
    `IText` | `scale1d(IVecI center, IVecI axis, double f)`
    `IText` | `scale1d(IVecI center, IVecI axis, IDoubleI f)`
    `IText` | `setColor(java.awt.Color c)`
    `IText` | `setColor(java.awt.Color c, int alpha)`
    `IText` | `setColor(double dgray)`
    `IText` | `setColor(double dgray, double dalpha)`
    `IText` | `setColor(double dr, double dg, double db)`
    `IText` | `setColor(double dr, double dg, double db, double da)`
    `IText` | `setColor(float fgray)`
    `IText` | `setColor(float fgray, float falpha)`
    `IText` | `setColor(float fr, float fg, float fb)`
    `IText` | `setColor(float fr, float fg, float fb, float fa)`
    `IText` | `setColor(int gray)`
    `IText` | `setColor(int gray, int alpha)`
    `IText` | `setColor(int r, int g, int b)`
    `IText` | `setColor(int r, int g, int b, int a)`
    `IText` | `setHSBColor(double h, double s, double b)`
    `IText` | `setHSBColor(double h, double s, double b, double a)`
    `IText` | `setHSBColor(float h, float s, float b)`
    `IText` | `setHSBColor(float h, float s, float b, float a)`
    `IText` | `shear(double sxy, double syx, double syz, double szy, double szx, double sxz)` shear operation
    `IText` | `shear(IDoubleI sxy, IDoubleI syx, IDoubleI syz, IDoubleI szy, IDoubleI szx, IDoubleI sxz)`
    `IText` | `shear(IVecI center, double sxy, double syx, double syz, double szy, double szx, double sxz)`
    `IText` | `shear(IVecI center, IDoubleI sxy, IDoubleI syx, IDoubleI syz, IDoubleI szy, IDoubleI szx, IDoubleI sxz)`
    `IText` | `shearXY(double sxy, double syx)`
    `IText` | `shearXY(IDoubleI sxy, IDoubleI syx)`
    `IText` | `shearXY(IVecI center, double sxy, double syx)`
    `IText` | `shearXY(IVecI center, IDoubleI sxy, IDoubleI syx)`
    `IText` | `shearYZ(double syz, double szy)`
    `IText` | `shearYZ(IDoubleI syz, IDoubleI szy)`
    `IText` | `shearYZ(IVecI center, double syz, double szy)`
    `IText` | `shearYZ(IVecI center, IDoubleI syz, IDoubleI szy)`
    `IText` | `shearZX(double szx, double sxz)`
    `IText` | `shearZX(IDoubleI szx, IDoubleI sxz)`
    `IText` | `shearZX(IVecI center, double szx, double sxz)`
    `IText` | `shearZX(IVecI center, IDoubleI szx, IDoubleI sxz)`
    `IText` | `show()`
    `IText` | `sub(double x, double y, double z)`
    `IText` | `sub(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IText` | `sub(IVecI v)`
    `java.lang.String` | `text()`
    `IText` | `text(java.lang.String txt)`
    `IText` | `transform(IMatrix3I mat)`
    `IText` | `transform(IMatrix4I mat)`
    `IText` | `transform(IVecI xvec, IVecI yvec, IVecI zvec)`
    `IText` | `transform(IVecI xvec, IVecI yvec, IVecI zvec, IVecI translate)`
    `IText` | `translate(double x, double y, double z)` translate() is alias of add()
    `IText` | `translate(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IText` | `translate(IVecI v)`
    `IVec` | `uvec()`
    `IText` | `uvec(IVecI v)`
    `IVec` | `vvec()`
    `IText` | `vvec(IVecI v)`
    `IText` | `weight(double w)`
    `IText` | `weight(float w)`

    - ### Methods inherited from class igeo.IObject

      `addDynamics, addUserData, addUserData, alpha, alphaInt, attr, attr, awtColor, blue, blueInt, brightness, castStringHashMap, clearDynamics, clearGraphics, clr, defaultAttribute, del, deletDynamics, deleteDynamics, deleteDynamics, deleteGraphic, dynamicsNum, getAWTColor, getColor, getDynamics, getGraphic, getGraphic, getParameter, graphicsNum, gray, grayInt, green, greenInt, grey, greyInt, hue, initGraphic, initObject, isValid, isVisible, layer, name, name, red, redInt, resetGraphic, saturation, server, setColor, setColor, setColor, setColor, setColor, setColor, setParameter, setTexture, syncColor, syncGraphic, syncVisibility, syncWeight, texture, updateGraphic, userData, userData, userData, userDataNum, visible, weight`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### defaultTextSize

          public static final double defaultTextSize

      See Also:
        Constant Field Values

    - #### text

          public ITextGeo text

    - #### font

          public java.awt.Font font

  - ### Constructor Detail

    - #### IText

          public IText(IServerI s,
                       java.lang.String str,
                       double fontSize,
                       IVecI pos,
                       IVecI textDir,
                       IVecI textUpDir)

    - #### IText

          public IText(IServerI s,
                       java.lang.String str,
                       double fontSize,
                       IVecI pos,
                       IVecI textDir)

    - #### IText

          public IText(IServerI s,
                       java.lang.String str,
                       double fontSize,
                       IVecI pos)

    - #### IText

          public IText(IServerI s,
                       java.lang.String str,
                       IVecI pos,
                       IVecI uvec,
                       IVecI vvec)

      Parameters:
        `uvec` - direction of text whose length is font size.
        `vvec` - direction of text height whose length is font size.

    - #### IText

          public IText(IServerI s,
                       java.lang.String str,
                       double fontSize,
                       double x,
                       double y,
                       double z,
                       double textDirX,
                       double textDirY,
                       double textDirZ,
                       double textUpDirX,
                       double textUpDirY,
                       double textUpDirZ)

    - #### IText

          public IText(IServerI s,
                       java.lang.String str,
                       double fontSize,
                       double x,
                       double y,
                       double z,
                       double textDirX,
                       double textDirY,
                       double textDirZ)

    - #### IText

          public IText(IServerI s,
                       java.lang.String str,
                       double fontSize,
                       double x,
                       double y,
                       double z)

    - #### IText

          public IText(IServerI s,
                       IText text)

    - #### IText

          public IText(java.lang.String str,
                       double fontSize,
                       IVecI pos,
                       IVecI textDir,
                       IVecI textUpDir)

    - #### IText

          public IText(java.lang.String str,
                       double fontSize,
                       IVecI pos,
                       IVecI textDir)

    - #### IText

          public IText(java.lang.String str,
                       double fontSize,
                       IVecI pos)

    - #### IText

          public IText(java.lang.String str,
                       IVecI pos,
                       IVecI uvec,
                       IVecI vvec)

      Parameters:
        `uvec` - direction of text whose length is font size.
        `vvec` - direction of text height whose length is font size.

    - #### IText

          public IText(java.lang.String str,
                       double fontSize,
                       double x,
                       double y,
                       double z,
                       double textDirX,
                       double textDirY,
                       double textDirZ,
                       double textUpDirX,
                       double textUpDirY,
                       double textUpDirZ)

    - #### IText

          public IText(java.lang.String str,
                       double fontSize,
                       double x,
                       double y,
                       double z,
                       double textDirX,
                       double textDirY,
                       double textDirZ)

    - #### IText

          public IText(java.lang.String str,
                       double fontSize,
                       double x,
                       double y,
                       double z)

    - #### IText

          public IText(IText text)

  - ### Method Detail

    - #### dup

          public IText dup()

      Description copied from class: `IObject`
      duplicate object
      Specified by:
        `dup` in interface `ITransformable`
      Overrides:
        `dup` in class `IGeometry`

    - #### cp

          public IText cp()

      alias of dup()
      Specified by:
        `cp` in interface `ITransformable`
      Overrides:
        `cp` in class `IGeometry`

    - #### initText

          public void initText(IServerI s)

    - #### createGraphic

          public IGraphicObject createGraphic(IGraphicMode m)

      Overrides:
        `createGraphic` in class `IObject`

    - #### corner

          public IVec corner(int i,
                             int j)

      Parameters:
        `i` - 0 is left corner, 1 is right corner
        `j` - 0 is bottom corner, 1 is top corner

    - #### font

          public java.awt.Font font()

    - #### font

          public IText font(java.awt.Font f)

    - #### font

          public IText font(processing.core.PFont f)

    - #### font

          public IText font(java.lang.String fontName,
                            int fontStyle,
                            int fontPixelResolution)

    - #### font

          public IText font(java.lang.String fontName,
                            int fontStyle)

    - #### font

          public IText font(java.lang.String fontName)

    - #### pos

          public IVec pos()

    - #### uvec

          public IVec uvec()

    - #### vvec

          public IVec vvec()

    - #### pos

          public IText pos(IVecI v)

    - #### uvec

          public IText uvec(IVecI v)

    - #### vvec

          public IText vvec(IVecI v)

    - #### text

          public java.lang.String text()

    - #### text

          public IText text(java.lang.String txt)

    - #### alignLeft

          public IText alignLeft()

    - #### alignCenter

          public IText alignCenter()

    - #### alignRight

          public IText alignRight()

    - #### alignTop

          public IText alignTop()

    - #### alignMiddle

          public IText alignMiddle()

    - #### alignBottom

          public IText alignBottom()

    - #### isAlignLeft

          public boolean isAlignLeft()

    - #### isAlignCenter

          public boolean isAlignCenter()

    - #### isAlignRight

          public boolean isAlignRight()

    - #### isAlignTop

          public boolean isAlignTop()

    - #### isAlignMiddle

          public boolean isAlignMiddle()

    - #### isAlignBottom

          public boolean isAlignBottom()

    - #### layer

          public IText layer(ILayer l)

      Set layer by ILayer object
      Overrides:
        `layer` in class `IGeometry`

    - #### layer

          public IText layer(java.lang.String layerName)

      Set layer by layer name. If the layer specified by the name is not existing in the server, a new layer is automatically created in the server
      Overrides:
        `layer` in class `IGeometry`

    - #### attr

          public IText attr(IAttribute at)

      Description copied from class: `IObject`
      set attributes
      Overrides:
        `attr` in class `IGeometry`

    - #### hide

          public IText hide()

      Overrides:
        `hide` in class `IGeometry`

    - #### show

          public IText show()

      Overrides:
        `show` in class `IGeometry`

    - #### clr

          public IText clr(IColor c)

      Description copied from class: `IObject`
      to set an object color
      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(IColor c,
                           int alpha)

      Description copied from class: `IObject`
      to set color, with alpha value overwritten
      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(IColor c,
                           float alpha)

      Description copied from class: `IObject`
      to set color, with alpha value overwritten
      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(IColor c,
                           double alpha)

      Description copied from class: `IObject`
      to set color, with alpha value overwritten
      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(IObject o)

      Description copied from class: `IObject`
      to set the same color with the object
      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(java.awt.Color c)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(java.awt.Color c,
                           int alpha)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(java.awt.Color c,
                           float alpha)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(java.awt.Color c,
                           double alpha)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(int gray)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(double dgray)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(float fgray)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(int gray,
                           int alpha)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(double dgray,
                           double dalpha)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(float fgray,
                           float falpha)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(int r,
                           int g,
                           int b)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(double dr,
                           double dg,
                           double db)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(float fr,
                           float fg,
                           float fb)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(int r,
                           int g,
                           int b,
                           int a)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(double dr,
                           double dg,
                           double db,
                           double da)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IText clr(float fr,
                           float fg,
                           float fb,
                           float fa)

      Overrides:
        `clr` in class `IGeometry`

    - #### hsb

          public IText hsb(double dh,
                           double ds,
                           double db,
                           double da)

      Overrides:
        `hsb` in class `IGeometry`

    - #### hsb

          public IText hsb(float h,
                           float s,
                           float b,
                           float a)

      Overrides:
        `hsb` in class `IGeometry`

    - #### hsb

          public IText hsb(double dh,
                           double ds,
                           double db)

      Overrides:
        `hsb` in class `IGeometry`

    - #### hsb

          public IText hsb(float h,
                           float s,
                           float b)

      Overrides:
        `hsb` in class `IGeometry`

    - #### setColor

          public IText setColor(java.awt.Color c)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IText setColor(java.awt.Color c,
                                int alpha)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IText setColor(int gray)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IText setColor(float fgray)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IText setColor(double dgray)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IText setColor(int gray,
                                int alpha)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IText setColor(float fgray,
                                float falpha)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IText setColor(double dgray,
                                double dalpha)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IText setColor(int r,
                                int g,
                                int b)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IText setColor(float fr,
                                float fg,
                                float fb)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IText setColor(double dr,
                                double dg,
                                double db)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IText setColor(int r,
                                int g,
                                int b,
                                int a)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IText setColor(float fr,
                                float fg,
                                float fb,
                                float fa)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IText setColor(double dr,
                                double dg,
                                double db,
                                double da)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setHSBColor

          public IText setHSBColor(float h,
                                   float s,
                                   float b,
                                   float a)

      Overrides:
        `setHSBColor` in class `IGeometry`

    - #### setHSBColor

          public IText setHSBColor(double h,
                                   double s,
                                   double b,
                                   double a)

      Overrides:
        `setHSBColor` in class `IGeometry`

    - #### setHSBColor

          public IText setHSBColor(float h,
                                   float s,
                                   float b)

      Overrides:
        `setHSBColor` in class `IGeometry`

    - #### setHSBColor

          public IText setHSBColor(double h,
                                   double s,
                                   double b)

      Overrides:
        `setHSBColor` in class `IGeometry`

    - #### weight

          public IText weight(double w)

      Overrides:
        `weight` in class `IGeometry`

    - #### weight

          public IText weight(float w)

      Overrides:
        `weight` in class `IGeometry`

    - #### add

          public IText add(double x,
                           double y,
                           double z)

      ITransformable API
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in class `IGeometry`

    - #### add

          public IText add(IDoubleI x,
                           IDoubleI y,
                           IDoubleI z)

      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in class `IGeometry`

    - #### add

          public IText add(IVecI v)

      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in class `IGeometry`

    - #### sub

          public IText sub(double x,
                           double y,
                           double z)

      Specified by:
        `sub` in interface `ITransformable`
      Specified by:
        `sub` in class `IGeometry`

    - #### sub

          public IText sub(IDoubleI x,
                           IDoubleI y,
                           IDoubleI z)

      Specified by:
        `sub` in interface `ITransformable`
      Specified by:
        `sub` in class `IGeometry`

    - #### sub

          public IText sub(IVecI v)

      Specified by:
        `sub` in interface `ITransformable`
      Specified by:
        `sub` in class `IGeometry`

    - #### mul

          public IText mul(IDoubleI v)

      Specified by:
        `mul` in interface `ITransformable`
      Specified by:
        `mul` in class `IGeometry`

    - #### mul

          public IText mul(double v)

      Specified by:
        `mul` in interface `ITransformable`
      Specified by:
        `mul` in class `IGeometry`

    - #### div

          public IText div(IDoubleI v)

      Specified by:
        `div` in interface `ITransformable`
      Specified by:
        `div` in class `IGeometry`

    - #### div

          public IText div(double v)

      Specified by:
        `div` in interface `ITransformable`
      Specified by:
        `div` in class `IGeometry`

    - #### neg

          public IText neg()

      Specified by:
        `neg` in interface `ITransformable`
      Specified by:
        `neg` in class `IGeometry`

    - #### rev

          public IText rev()

      alias of neg

    - #### flip

          public IText flip()

      alias of neg
      Specified by:
        `flip` in interface `ITransformable`
      Specified by:
        `flip` in class `IGeometry`

    - #### add

          public IText add(IVecI v,
                           double f)

      scale add
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in class `IGeometry`

    - #### add

          public IText add(IVecI v,
                           IDoubleI f)

      scale add
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in class `IGeometry`

    - #### add

          public IText add(double f,
                           IVecI v)

      scale add alias
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in class `IGeometry`

    - #### add

          public IText add(IDoubleI f,
                           IVecI v)

      scale add alias
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in class `IGeometry`

    - #### rot

          public IText rot(IDoubleI angle)

      rotation around z-axis and origin
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IText rot(double angle)

      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IText rot(IVecI axis,
                           IDoubleI angle)

      rotation around axis vector
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IText rot(IVecI axis,
                           double angle)

      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IText rot(IVecI center,
                           IVecI axis,
                           IDoubleI angle)

      rotation around axis vector and center
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IText rot(IVecI center,
                           IVecI axis,
                           double angle)

      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IText rot(IVecI axis,
                           IVecI destDir)

      rotate to destination direction vector
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IText rot(IVecI center,
                           IVecI axis,
                           IVecI destPt)

      rotate to destination point location
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot2

          public IText rot2(IDoubleI angle)

      rotation on xy-plane around origin; same with rot(IDoubleI)
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in class `IGeometry`

    - #### rot2

          public IText rot2(double angle)

      rotation on xy-plane around origin; same with rot(double)
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in class `IGeometry`

    - #### rot2

          public IText rot2(IVecI center,
                            IDoubleI angle)

      rotation on xy-plane around center
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in class `IGeometry`

    - #### rot2

          public IText rot2(IVecI center,
                            double angle)

      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in class `IGeometry`

    - #### rot2

          public IText rot2(IVecI destDir)

      rotation on xy-plane to destination direction vector
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in class `IGeometry`

    - #### rot2

          public IText rot2(IVecI center,
                            IVecI destPt)

      rotation on xy-plane to destination point location
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in class `IGeometry`

    - #### scale

          public IText scale(IDoubleI f)

      alias of mul
      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in class `IGeometry`

    - #### scale

          public IText scale(double f)

      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in class `IGeometry`

    - #### scale

          public IText scale(IVecI center,
                             IDoubleI f)

      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in class `IGeometry`

    - #### scale

          public IText scale(IVecI center,
                             double f)

      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in class `IGeometry`

    - #### scale1d

          public IText scale1d(IVecI axis,
                               double f)

      scale only in 1 direction
      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in class `IGeometry`

    - #### scale1d

          public IText scale1d(IVecI axis,
                               IDoubleI f)

      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in class `IGeometry`

    - #### scale1d

          public IText scale1d(IVecI center,
                               IVecI axis,
                               double f)

      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in class `IGeometry`

    - #### scale1d

          public IText scale1d(IVecI center,
                               IVecI axis,
                               IDoubleI f)

      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in class `IGeometry`

    - #### ref

          public IText ref(IVecI planeDir)

      reflect(mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `ref` in interface `ITransformable`
      Specified by:
        `ref` in class `IGeometry`

    - #### ref

          public IText ref(IVecI center,
                           IVecI planeDir)

      Specified by:
        `ref` in interface `ITransformable`
      Specified by:
        `ref` in class `IGeometry`

    - #### mirror

          public IText mirror(IVecI planeDir)

      mirror is alias of ref
      Specified by:
        `mirror` in interface `ITransformable`
      Specified by:
        `mirror` in class `IGeometry`

    - #### mirror

          public IText mirror(IVecI center,
                              IVecI planeDir)

      Specified by:
        `mirror` in interface `ITransformable`
      Specified by:
        `mirror` in class `IGeometry`

    - #### shear

          public IText shear(double sxy,
                             double syx,
                             double syz,
                             double szy,
                             double szx,
                             double sxz)

      shear operation
      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in class `IGeometry`

    - #### shear

          public IText shear(IDoubleI sxy,
                             IDoubleI syx,
                             IDoubleI syz,
                             IDoubleI szy,
                             IDoubleI szx,
                             IDoubleI sxz)

      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in class `IGeometry`

    - #### shear

          public IText shear(IVecI center,
                             double sxy,
                             double syx,
                             double syz,
                             double szy,
                             double szx,
                             double sxz)

      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in class `IGeometry`

    - #### shear

          public IText shear(IVecI center,
                             IDoubleI sxy,
                             IDoubleI syx,
                             IDoubleI syz,
                             IDoubleI szy,
                             IDoubleI szx,
                             IDoubleI sxz)

      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in class `IGeometry`

    - #### shearXY

          public IText shearXY(double sxy,
                               double syx)

      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in class `IGeometry`

    - #### shearXY

          public IText shearXY(IDoubleI sxy,
                               IDoubleI syx)

      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in class `IGeometry`

    - #### shearXY

          public IText shearXY(IVecI center,
                               double sxy,
                               double syx)

      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in class `IGeometry`

    - #### shearXY

          public IText shearXY(IVecI center,
                               IDoubleI sxy,
                               IDoubleI syx)

      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in class `IGeometry`

    - #### shearYZ

          public IText shearYZ(double syz,
                               double szy)

      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in class `IGeometry`

    - #### shearYZ

          public IText shearYZ(IDoubleI syz,
                               IDoubleI szy)

      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in class `IGeometry`

    - #### shearYZ

          public IText shearYZ(IVecI center,
                               double syz,
                               double szy)

      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in class `IGeometry`

    - #### shearYZ

          public IText shearYZ(IVecI center,
                               IDoubleI syz,
                               IDoubleI szy)

      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in class `IGeometry`

    - #### shearZX

          public IText shearZX(double szx,
                               double sxz)

      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in class `IGeometry`

    - #### shearZX

          public IText shearZX(IDoubleI szx,
                               IDoubleI sxz)

      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in class `IGeometry`

    - #### shearZX

          public IText shearZX(IVecI center,
                               double szx,
                               double sxz)

      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in class `IGeometry`

    - #### shearZX

          public IText shearZX(IVecI center,
                               IDoubleI szx,
                               IDoubleI sxz)

      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in class `IGeometry`

    - #### mv

          public IText mv(double x,
                          double y,
                          double z)

      mv() is alias of add()
      Specified by:
        `mv` in interface `ITransformable`
      Specified by:
        `mv` in class `IGeometry`

    - #### mv

          public IText mv(IDoubleI x,
                          IDoubleI y,
                          IDoubleI z)

      Specified by:
        `mv` in interface `ITransformable`
      Specified by:
        `mv` in class `IGeometry`

    - #### mv

          public IText mv(IVecI v)

      Specified by:
        `mv` in interface `ITransformable`
      Specified by:
        `mv` in class `IGeometry`

    - #### cp

          public IText cp(double x,
                          double y,
                          double z)

      cp() is alias of dup().add()
      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in class `IGeometry`

    - #### cp

          public IText cp(IDoubleI x,
                          IDoubleI y,
                          IDoubleI z)

      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in class `IGeometry`

    - #### cp

          public IText cp(IVecI v)

      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in class `IGeometry`

    - #### translate

          public IText translate(double x,
                                 double y,
                                 double z)

      translate() is alias of add()
      Specified by:
        `translate` in interface `ITransformable`
      Specified by:
        `translate` in class `IGeometry`

    - #### translate

          public IText translate(IDoubleI x,
                                 IDoubleI y,
                                 IDoubleI z)

      Specified by:
        `translate` in interface `ITransformable`
      Specified by:
        `translate` in class `IGeometry`

    - #### translate

          public IText translate(IVecI v)

      Specified by:
        `translate` in interface `ITransformable`
      Specified by:
        `translate` in class `IGeometry`

    - #### transform

          public IText transform(IMatrix3I mat)

      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in class `IGeometry`

    - #### transform

          public IText transform(IMatrix4I mat)

      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in class `IGeometry`

    - #### transform

          public IText transform(IVecI xvec,
                                 IVecI yvec,
                                 IVecI zvec)

      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in class `IGeometry`

    - #### transform

          public IText transform(IVecI xvec,
                                 IVecI yvec,
                                 IVecI zvec,
                                 IVecI translate)

      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in class `IGeometry`

    - #### center

          public IVec center()

      returns center of geometry object
      Specified by:
        `center` in class `IGeometry`